"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.serverlessRestful = void 0;
const netlifyData_1 = require("./netlifyData");
const serverlessRestful = (event) => (actions) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const parsedRequestObject = {
        path: event.path,
        query: event.queryStringParameters,
        body: JSON.parse(event.body || '{}'),
    };
    try {
        let ranAction;
        switch (event.httpMethod) {
            case 'GET':
                if (!actions.get)
                    throw new Error('Page Not Found');
                ranAction = yield actions.get(parsedRequestObject);
                break;
            case 'POST':
                if (!actions.post)
                    throw new Error('Page Not Found');
                ranAction = yield actions.post(parsedRequestObject);
                break;
            case 'PUT':
                if (!actions.put)
                    throw new Error('Page Not Found');
                ranAction = yield actions.put(parsedRequestObject);
                break;
            case 'PATCH':
                if (!actions.patch)
                    throw new Error('Page Not Found');
                ranAction = yield actions.patch(parsedRequestObject);
                break;
            case 'DELETE':
                if (!actions.delete)
                    throw new Error('Page Not Found');
                ranAction = yield actions.delete(parsedRequestObject);
                break;
            default:
                ranAction = {
                    status: 404,
                    data: {
                        success: false,
                        message: 'Page Not Found',
                    },
                };
                break;
        }
        return netlifyData_1.netlifyData(ranAction.data, (_a = ranAction.status) !== null && _a !== void 0 ? _a : 200);
    }
    catch (e) {
        return netlifyData_1.netlifyData({
            success: false,
            message: 'Page Not Found',
        }, 404);
    }
});
exports.serverlessRestful = serverlessRestful;
//# sourceMappingURL=serverlessRestful.js.map